# sb::Content::Common
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2005 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Content::Common;
use vars qw( $VERSION );
$VERSION = '0.01';
# 0.01 [2007/08/12] added _init
# 0.00 [2007/07/31] divided from sb::Content
# --------------------------------------
# // defines / static variables
sub CATEGORY_TITLE (){ '%Main%::%Sub%' };
sub PREV_ARROW     (){ '&lt;&lt;' };
sub NEXT_ARROW     (){ '&gt;&gt;' };
# --------------------------------------
# // default callbacks
sub _init
{
	return (
		'_00main' => \&_main,
		'title'   => \&_title,
		'page'    => \&_page,
		'option'  => \&_option,
	);
}
# --------------------------------------
# // define callbacks
sub _css_output
{ # for css
	my $cms = shift;
	my %var = @_;
	$cms->num(0);
	$cms->tag('site_parts'=>$var{'conf'}->value('conf_srv_base') . $var{'conf'}->value('dir_style'));
	$cms->tag('site_encoding'=>$var{'lang'}->charset);
	return $cms->output;
}
sub _main
{ # block independent parts
	my $cms = shift;
	my %var = @_;
	my $title = $var{'blog'}->title;
	my $srvbase = $var{'conf'}->value('conf_srv_base');
	my $selected = '';
	$title .= ' | ' . $var{'entry'}->[0]->subj if ($var{'mode'} eq 'ent');
	$selected = $var{'cat'}->{$var{'id'}}->fullname($var{'cat'},CATEGORY_TITLE) if ($var{'mode'} eq 'cat');
	$selected = join('/',( $var{'cond'} =~ /(\d\d\d\d)(\d\d)(\d\d)?/ )) if ($var{'mode'} eq 'arc');
	$selected =~ s/\/$// if ($var{'mode'} eq 'arc' and $selected =~ /\/$/);
	$title .= ' | ' . $selected if ($selected);
	$selected = 'Search: ' . $var{'cond'} if ($var{'mode'} eq 'srch');
	$cms->num(0);
	$cms->tag('site_css'=>$var{'css'});
	$cms->tag('site_title'=>$title);
	$cms->tag('selected_archive'=>$selected);
	$cms->tag('site_cgi'=>$var{'conf'}->value('conf_srv_cgi') . $var{'conf'}->value('basic_sb'));
	$cms->tag('site_mobile'=>$var{'conf'}->value('conf_srv_cgi') . $var{'conf'}->value('basic_mob'));
	$cms->tag('site_rss'=>$srvbase . $var{'conf'}->value('conf_dir_log') . $var{'conf'}->value('file_rss'));
	$cms->tag('site_atom'=>$srvbase . $var{'conf'}->value('conf_dir_log') . $var{'conf'}->value('file_atom'));
	$cms->tag('site_rsd'=>$var{'conf'}->value('conf_srv_cgi') . $var{'conf'}->value('basic_rsd'));
	$cms->tag('site_top'=>$srvbase);
	$cms->tag('site_encoding'=>$var{'lang'}->charset);
	$cms->tag('site_lang'=>$var{'lang'}->language);
	$cms->tag('site_parts'=>$var{'conf'}->value('conf_srv_base') . $var{'conf'}->value('dir_style'));
	$cms->tag('script_version'=>$sb::VERSION);
	$cms->tag('script_name'=>$sb::PRODUCT);
	$cms->tag('script_webpage'=>$sb::WEBPAGE);
	my $name = 
		  ($var{'mode'} eq 'ent')                             ? 'entry'
		: ($var{'mode'} eq 'arc' and $var{'cond'} =~ /\d{8}/) ? 'daily'
		: ($var{'mode'} eq 'arc' and $var{'cond'} =~ /\d{6}/) ? 'monthly'
		: ($var{'mode'} eq 'srch')                            ? 'search'
		: ($var{'mode'} eq 'cat')                             ? 'category'
		: ($var{'mode'} eq 'user')                            ? 'profile'
		:                                                       'page';
	$cms->tag('mode_name'=>$name);
	my $id = 
	  ($var{'mode'} eq 'page')                          ? $var{'page'}
	: ($var{'mode'} eq 'arc' or $var{'mode'} eq 'srch') ? $var{'cond'}
	:                                                     $var{'id'};
	$cms->tag('mode_id'=>$id);
	return 1;
}
sub _title
{
	my $cms = shift;
	my %var = @_;
	my $toplink = $var{'conf'}->value('conf_srv_base');
	$cms->num(0);
	$cms->tag('blog_name_only'=>$var{'blog'}->title);
	$cms->tag('blog_name'=>'<a href="' . $toplink . '">' . $var{'blog'}->title . '</a>');
	$cms->tag('blog_description'=>sb::Text->new($var{'blog'}->text)->format(1));
	return 1;
}
sub _page
{
	my $cms = shift;
	my %var = @_;
	return if ($var{'page'} == -1 or $var{'mode'} eq 'ent' or $var{'mode'} eq 'user');
	my $disp = ( $var{'num'} > 0 ) ? $var{'num'} : 1;
	my $page_num = int($var{'entry_num'} / $disp);
	my $cgi = ($var{'mode'} ne 'mob')
		? $var{'conf'}->value('conf_srv_cgi') . $var{'conf'}->value('basic_sb') . '?page='
		: $var{'conf'}->value('conf_srv_cgi') . $var{'conf'}->value('basic_mob') . '?page=';
	my $query = '';
	my $prev_url = '';
	my $next_url = '';
	$cms->num(0);
	$page_num++ if ($var{'entry_num'} % $disp != 0 and $var{'entry_num'} > 0);
	$cms->tag('page_num'=>$page_num);
	$cms->tag('page_now'=>$var{'page'} + 1);
	$query = 'cid=' . $var{'id'} if ($var{'mode'} eq 'cat' or $var{'mode'} eq 'mob' and $var{'id'} ne '');
	$query = 'month=' . $var{'cond'} if ($var{'mode'} eq 'arc' and $var{'cond'} =~ /^\d{6}$/);
	$query = 'day=' . $var{'cond'} if ($var{'mode'} eq 'arc' and $var{'cond'} =~ /^\d{8}$/);
	if ($var{'mode'} eq 'srch')
	{
		my $text = $var{'cond'};
		$text =~ s/(\W)/'%' . unpack('H2', $1)/eg;
		$query = 'search=' . $text;
	}
	$prev_url = $cgi . ($var{'page'} - 1) if ($var{'page'} > 0);
	$next_url = $cgi . ($var{'page'} + 1) if ($var{'page'} < ($page_num - 1));
	$prev_url .= '&amp;' . $query if ($query and $prev_url);
	$next_url .= '&amp;' . $query if ($query and $next_url);
	$cms->tag('prev_page_url'=>$prev_url);
	$cms->tag('prev_page_link'=>'<a href="' . $prev_url . '">' . PREV_ARROW . '</a>') if ($prev_url);
	$cms->tag('next_page_url'=>$next_url);
	$cms->tag('next_page_link'=>'<a href="' . $next_url . '">'. NEXT_ARROW . '</a>') if ($next_url);
	return 1;
}
sub _option
{
	my $cms = shift;
	my %var = @_;
	$cms->deleteBlock('option') if ( $var{'mode'} ne 'ent' );
	return ( $var{'mode'} eq 'ent' ) ? 1 : 0;
}
1;
__END__
