# sb::Data::Template
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Data::Template;
use strict;
use sb::Data::Object ();
use base qw( sb::Data::Object );
use vars qw( $VERSION );
$VERSION = '0.03';
# 0.03 [2007/08/04] added initializer
# 0.02 [2007/02/11] ported from biscuit
# 0.01 [2005/07/22] changed data structure to array
# 0.00 [2005/02/02] generated
# --------------------------------------
# // defines / static variables
# ... nothing ...
# --------------------------------------
# // override base class - table
sub table
{
	my $self = shift;
	return (
		'id'    => 'uni_id',   # id
		'wid'   => 'id',       # weblog id (reserved)
		'use'   => 'int',      # current template flag
		'name'  => 'str(255)', # template name
		'gen'   => 'date',     # date of generation
		'mod'   => 'date',     # date of modification
		'info'  => 'text',     # template information
		'main'  => 'text',     # base template
		'css'   => 'text',     # style sheet
		'entry' => 'text',     # article template
		'files' => 'text',     # included files
	);
}
# --------------------------------------
# // initializer
BEGIN
{
	__PACKAGE__->init_accessor();
}
sub default
{ # default settings
	my $self  = shift;
	my %param = @_;
	$param{'wid'} |= 0;
	$self->SUPER::initialize(%param);
}
# --------------------------------------
# // public functions
# --------------------------------------
# // private functions
1;
__END__
